# Penn Treebank LM data

The text data from the Penn Treebank (PTB) is widely used as a language modeling
corpus. There are several different versions of the dataset (different splits,
different amounts of preprocessing), so I've put them all here in one place.

The PTB syntactic and POS annotations can be obtained from the LDC.


## `mikolov/`

This is the widely-used Mikolov version of the PTB. Most papers on neural
language models (RNN variants, regularization, etc.) include an evaluation on
this version of the PTB. Typically, sentences are not modeled independently,
but rather as a single string of text.

 * Summary: Closed vocabulary
    - 9,999 word types, including 1 OOV type
 * Preprocessing: tokenized, lowercased, vocab cutoffs, numbers collapsed to N,
   no punctuation
 * Counts
    - Lines train=42,068 valid=3,370 test=3,761
    - Words train=887,521 valid=70,390 test=78,669 (total=1,036,580)
 * Paper: https://www.isca-speech.org/archive/archive_papers/interspeech_2010/i10_1045.pdf


## `rnng/`

Syntactic models, such as recurrent neural network grammars (RNNGs) general use
this split. They generally model each sentence independently.

 * Summary: Closed vocabulary
    - 23,815 word types, including 49 OOV types
 * Preprocessing: tokenized, vocab cutoffs
 * Counts
    - Lines train=39,831 valid=1,346 test=2,416
    - Words train=950,012 valid=32,897 test=56,684 (total=1,039,593)
    - Corresponds to sections 2-21 train; 24 valid; 23 valid (standard parsing
      split)
 * Paper: https://www.aclweb.org/anthology/N16-1024


## `raw/`

Count-based and non-parametric models are appropriate to fit on the raw data.
Most pap

 * Summary: Open vocabulary (valid and test have types that do not occur in
   training)
     - 44,387; no OOV type
     - validation/test sets contain vocabulry not present in train
     - closed character set
 * Preprocessing: tokenized
 * Counts (same as `rnng/`)
    - Lines train=39,831 valid=1,346 test=2,416
    - Words train=950,012 valid=32,897 test=56,684 (total=1,039,593)
    - Corresponds to sections 2-21 train; 24 valid; 23 valid (standard parsing
      split)

